
      SUBROUTINE EFLD( XI, YI, UZI, AI, IJ)
C     COMPUTE NEAR E FIELDS OF A SEGMENT WITH SINE, COSINE, AND
C     CONSTANT CURRENTS.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'dataj.inc'
      COMPLEX*16 TEZS, TERS, TEZC, TERC, TEZK, TERK
      PARAMETER (PI=3.141592653589793D0)
      DATA   ETA/376.73D0/
      TP=2*PI
      XIJ= XI- XJ
      YIJ= YI- YJ
      IJX= IJ
      SALPR= SALPJ
      UZIJ= UZI-  RZJ
      UZP= XIJ* CABJ+ YIJ* SABJ+ UZIJ* SALPR
      RHOX= XIJ- CABJ* UZP
      RHOY= YIJ- SABJ* UZP
      RHOZ= UZIJ- SALPR* UZP
      RH= SQRT( RHOX* RHOX+ RHOY* RHOY+ RHOZ* RHOZ+ AI* AI)
      IF( RH.GT.1.D-10) GOTO 1
      RHOX=0.
      RHOY=0.
      RHOZ=0.
      GOTO 2
    1 RHOX= RHOX/ RH
      RHOY= RHOY/ RH
      RHOZ= RHOZ/ RH
    2 R= SQRT( UZP* UZP+ RH* RH)
C
C     LUMPED CURRENT ELEMENT APPROX. FOR LARGE SEPARATIONS
C
      IF( R.LT. RKH) GOTO 3
      RMAG= TP* R
      CTH= UZP/ R
      PX= RH/ R
      ZEXK= CMPLX( COS( RMAG),- SIN( RMAG))
      PY= TP* R* R
      ZEYK= ETA* CTH* ZEXK* CMPLX(1.D0,-1.D0/ RMAG)/ PY
      ZEZK= ETA* PX* ZEXK* CMPLX(1.D0, RMAG-1.D0/ RMAG)/(2.* PY)
      TEZK= ZEYK* CTH- ZEZK* PX
      TERK= ZEYK* PX+ ZEZK* CTH
      RMAG= SIN( PI* S)/ PI
      TEZC= TEZK* RMAG
      TERC= TERK* RMAG
      TEZK= TEZK* S
      TERK= TERK* S
      ZEXS=(0.,0.)
      ZEYS=(0.,0.)
      ZEZS=(0.,0.)
      GOTO 6
C
C     EKSC FOR THIN WIRE APPROX. OR EKSCX FOR EXTENDED T.W. APPROX.
C
    3 IF( IEXK.EQ.1) GOTO 4
      CALL EKSC( S,UZP,RH,TP,IJX,TEZS,TERS,TEZC,TERC,TEZK,TERK)
      GOTO 5
    4 CALL EKSCX(B,S,UZP,RH,IJX,IND1,IND2,TEZS,TERS,TEZC,
     &TERC, TEZK, TERK)
    5 CONTINUE
      ZEXS= TEZS* CABJ+ TERS* RHOX
      ZEYS= TEZS* SABJ+ TERS* RHOY
      ZEZS= TEZS* SALPR+ TERS* RHOZ
    6 ZEXK= TEZK* CABJ+ TERK* RHOX
      ZEYK= TEZK* SABJ+ TERK* RHOY
      ZEZK= TEZK* SALPR+ TERK* RHOZ
      ZEXC= TEZC* CABJ+ TERC* RHOX
      ZEYC= TEZC* SABJ+ TERC* RHOY
      ZEZC= TEZC* SALPR+ TERC* RHOZ
      RETURN
      END
